; DST_Dust-Engine V1.0
 
Global DST_Looptime#,DST_TIMER,DST_CHECKTIMER,dst_check,DST_TempPivot
Const dst_sharesize=200

.dustobject
Type DST_Dustobject
 Field pivot  ; Stammobjekt fr die Partikel und Dustzonen
 Field campivot  ; Steuerobjekt fr die Partikelplazierung
 Field camera ; zugewiesenes Cameraobjekt
 Field active ; Dust-Objekt aktiv/inaktiv
 Field dense# ; wird ber dst_checkzones() ermittelt
 Field dense_akt# ;dichtesteuerung bei eintritt od.verlassen der zonen
 Field count  ; Anzahl der Partikel
 Field version   ; Art der Partikel (0=2 oder 1=4 Triangles )
 Field count_zone  ; zahl der vergebenen Dustzonen
 Field sharecount ; zahl der sich berschneidenden Zonen an Camera-pos.
 Field oldcount    ; vorher. zahl der sich berschneidenden Zonen an Camera-pos.
 Field zones[dst_sharesize]
 Field dist_akt#  ; positionsdifferenz zw. camera und campivot seit letztem durchlauf
 Field part_count ; zahl der momentan aktiven partikel
End Type
.dustzone
Type DST_Dustzone
 Field pivot  ; Referenzobjekt fr Entfernungsmessung
 Field dust_handle    ; Typehandle der Dustzone
 Field priority ; Prioritt der Zone
 Field brush   ; Brush mit allen eigenschaften fr die Partikel
 Field radius# ; Grsse der Dustzone ( Global )
 Field active ; Dust-Zone aktiv/inaktiv
 Field dense#  ; Dichte der Partikel (part./entf.)
 Field farfade_min#  ; min-Entfern. fr Autofade
 Field farfade_max#  ; max-Entfern. fr Autofade
 Field clipradius#   ; Entfernung ab der Partikel entfernt bzw. eingesetzt werden
 Field nearfade_min#  ; min-Entfern. fr Nearfade
 Field nearfade_max#  ; max-Entfern. fr Nearfade
 Field texture  ; Texturhandle fr Partikel
 Field file$    ; Texturdatei (ohne Pfad)
 Field flag     ; Texturflags fr Textur
 Field texblend ; Textur-Blendmode
 Field Tex_scale_x# ; Scalefaktor fr Textur
 Field Tex_scale_y# ; Scalefaktor fr Textur
 Field size_min#  ; Partikel-Grsse min
 Field size_max#  ; Partikel-Grsse max
 Field alpha_min#  ; Partikel-Alpha min
 Field alpha_max#  ; Partikel-Alpha max
 Field blendmode ; Partikel blendmode
 Field part_flag ; Entityflags fr partikel
 Field r1,g1,b1  ; Particle-Color-Range 
 Field r2,g2,b2  ;    - " -					  
 Field dyn_alpha ; dynamisches Alphablending 1/0
 Field speedblur# ;faktor fr Verzerrung der partikel durch hohe geschwindigkeit
 Field angle_min#,angle_max# ; Z-Winkel-bereich
 Field rot_min#,rot_max# ; Rotationsgeschwindigkeitsbereich
End Type
.dust_partikel
Type DST_Particle
 Field part ; Partikel Handle
 Field partpivot ; Partikel-pivot Handle
 Field dust_handle ; Typehandle des bergeordeten Dust-objekts
 Field zone_handle   ; Typehandle der Dustzone, zu der das Partikel zur Zeit gehrt
 Field active     ; Partikel in Gebrauch 1/0
 Field dist_old# ; bisherige Distanz zur Camera
 Field alpha# ; Alpha-Wert
 Field alphaflag ; gibt an ob der alpha-wert durch Annherung gendert wird oder durch einblenden/ausblenden nach plazieren
 Field alphaakt# ; akt. errechneter Alpha-faktor fr alphaflag=1
 Field alphadest#  ; gibt den ziel alpha-faktor an, der erreicht werden soll, wenn alphaflag auf 1 steht
 Field rot#    ; Rotationsgeschwindigkeit
 Field angle#  ; akt. Z-Winkel
 Field startangle#  ; anfangs-Z-Winkel
 Field old_x#,old_y#,old_z#  ;vorherige pos. des partikels
 Field old_pi#,old_ya#,old_ro#  ;vorherige ausricht. des partikels
End Type


 
Function DST_Create_Dust(dst_cam,dst_count,dst_typ=0)
 If dst_temppivot=0 Then dst_temppivot=CreatePivot()
 dst_dust.DST_Dustobject = New DST_Dustobject
 dst_dust\camera=dst_cam
 dst_dust\pivot=CreatePivot()
 dst_dust\campivot=CreatePivot(dst_dust\camera)
; PositionEntity dst_dust\campivot,0,0,0 : RotateEntity dst_dust\campivot,0,0,0
 EntityParent dst_dust\campivot,dst_dust\pivot
 dst_dust\version=dst_typ
 dst_dust\count=dst_count
 dst_dust\active=1
 dst_x#=EntityX#(dst_dust\camera,1) : dst_y#=EntityY#(dst_dust\camera,1) : dst_z#=EntityZ#(dst_dust\camera,1)
 dst_dust\dense#=1 : dst_dust\dense_akt#=0
 For dst_a=1 To dst_count
  dst_part.DST_Particle = New DST_Particle
  dst_part\partpivot=CreatePivot()
  dst_part\dust_handle=Handle(dst_dust.DST_Dustobject)
  If dst_dust\version=0 Then dst_part\part=dst_createflat1(dst_part\partpivot) Else dst_part\part=dst_createflat2(dst_part\partpivot)
  PositionEntity dst_part\partpivot,Rand(-100,100)+dst_x#,Rand(-100,100)+dst_y#,Rand(-100,100)+dst_z#
  EntityAutoFade dst_part\part,80,100
  dst_part\alpha#=1.0 : dst_part\alphaakt#=1.0
  dst_part\dist_old = EntityDistance(dst_part\part,dst_dust\camera)
  HideEntity dst_part\partpivot
 Next
 Return dst_dust\pivot
End Function

Function DST_Create_Dustzone(dst_dust_handle,dst_clamp=0)
 dst_zone.DST_Dustzone = New DST_Dustzone
 dst_zone\pivot=CreatePivot()
 If dst_clamp>0 Then EntityParent dst_zone\pivot,dst_dust_handle
 dst_zone\brush=CreateBrush()
 For dst_dust.DST_Dustobject = Each DST_Dustobject
  If dst_dust\pivot=dst_dust_handle
   dst_zone\dust_handle=Handle(dst_dust.DST_Dustobject)
   Exit
  EndIf
 Next
 dst_zone\size_min#=1 : dst_zone\size_max#=1
 dst_zone\alpha_min#=1 : dst_zone\alpha_max#=1
 dst_zone\r1=255 : dst_zone\g1=255 : dst_zone\b1=255
 dst_zone\r2=255 : dst_zone\g2=255 : dst_zone\b2=255
 dst_zone\active=1 : dst_zone\dense#=1
 dst_zone\farfade_min#=80 : dst_zone\farfade_max#=100
 dst_zone\clipradius#=(dst_zone\farfade_max#+dst_zone\size_max#)
 Return dst_zone\pivot
End Function

Function DST_Free_Dust(dst_dust)
 For dst_dust2.DST_Dustobject = Each DST_Dustobject
  If dst_dust2\pivot=dst_dust
   For dst_part.DST_Particle = Each DST_Particle
    If dst_part\dust_handle=Handle (dst_dust2.DST_Dustobject)
     FreeEntity dst_part\partpivot : Delete dst_part
    EndIf
   Next
   For dst_zone.DST_Dustzone = Each DST_Dustzone
    If dst_zone\dust_handle=Handle (dst_dust2.DST_Dustobject)
     FreeEntity dst_zone\pivot : FreeTexture dst_zone\texture : FreeBrush dst_zone\brush
     Delete dst_zone
    EndIf
   Next
   FreeEntity dst_dust2\pivot : Delete dst_dust2
   Exit
  EndIf
 Next
 If First dst_dustobject=Null And dst_temppivot<>0 Then FreeEntity dst_temppivot : dst_temppivot=0
End Function

Function DST_Free_DustZone(dst_zone)
 For dst_zone2.DST_Dustzone = Each DST_Dustzone
  If dst_zone2\pivot=dst_zone
   FreeEntity dst_zone2\pivot : FreeTexture dst_zone2\texture : FreeBrush dst_zone2\brush
   Delete dst_zone2 : Exit
  EndIf
 Next
dst_checkzones()
End Function

Function DST_SetTimer()
DST_TIMER=MilliSecs()
End Function

Function DST_Set_Intervall(dst_val)
DST_CHECKTIMER=dst_val
End Function

Function DST_Set_ZoneRadius(dst_zone,dst_radius#)
 For dst_zone2.DST_Dustzone = Each DST_Dustzone
  If dst_zone2\pivot=dst_zone
   dst_zone2\radius#=dst_radius#
   Exit
  EndIf
 Next
dst_checkzones()
End Function

Function DST_Change_Camera(dst_dust,dst_camera)
 For dst_dust2.DST_Dustobject = Each DST_Dustobject
  If dst_dust2\pivot=dst_dust
   dst_dust2\camera=dst_camera
   EntityParent dst_dust2\campivot,dst_dust2\camera
   PositionEntity dst_dust2\campivot,0,0,0
   Exit
  EndIf
 Next
dst_checkzones()
End Function


Function DST_Set_DustStatus(dst_dust,dst_flag)
 For dst_dust2.DST_Dustobject = Each DST_Dustobject
  If dst_dust2\pivot=dst_dust
   If dst_flag>=1 Then dst_flag=1
   If dst_flag<1 Then dst_flag=0
   dst_dust2\active=dst_flag
   Exit
  EndIf
 Next
dst_checkzones()
End Function

Function DST_Set_DustZoneStatus(dst_zone,dst_flag)
 For dst_zone2.DST_Dustzone = Each DST_Dustzone
  If dst_zone2\pivot=dst_zone
   If dst_flag>=1 Then dst_flag=1
   If dst_flag<1 Then dst_flag=0
   dst_zone2\active=dst_flag
   Exit
  EndIf
 Next
dst_checkzones()
End Function

Function DST_Set_DustZonePriority(dst_zone,dst_flag)
 For dst_zone2.DST_Dustzone = Each DST_Dustzone
  If dst_zone2\pivot=dst_zone
   dst_zone2\priority=dst_flag
   Exit
  EndIf
 Next
dst_checkzones()
End Function

Function DST_Set_Dense(dst_zone,dst_val#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
     dst_zone2\dense#=dst_val#
     Exit
    EndIf
   Next
End Function


Function DST_Set_Texture(dst_zone,dst_file$,dst_flag)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
     dst_zone2\texture=LoadTexture(dst_file$,dst_flag)
     If dst_zone2\texture<>0
      dst_b$=dst_flipstring$(dst_file$)
      dst_a=Instr(dst_b$,"\",1)
      If dst_a>0 Then dst_b$=dst_flipstring$(Left$(dst_b$,dst_a-1)) Else dst_b$=dst_file$
      dst_zone2\file$=dst_b$ : dst_zone2\flag=dst_flag
      BrushTexture dst_zone2\brush,dst_zone2\texture
     EndIf
     Exit
    EndIf
   Next
End Function

Function DST_Set_TextureBlend(dst_zone,dst_blend)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
     TextureBlend dst_zone2\texture,dst_blend
     dst_zone2\texblend=dst_blend
     Exit
    EndIf
   Next
End Function

Function DST_Set_TextureScale(dst_zone,dst_scx#,dst_scy#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
     ScaleTexture dst_zone2\texture,dst_scx#,dst_scy#
     dst_zone2\tex_scale_x#=dst_scx#
     dst_zone2\tex_scale_y#=dst_scy#
     Exit
    EndIf
   Next
End Function

Function DST_Set_ColorRange(dst_zone,dst_r1,dst_g1,dst_b1,dst_r2,dst_g2,dst_b2)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\r1=dst_r1 : dst_zone2\g1=dst_g1 : dst_zone2\b1=dst_b1
    dst_zone2\r2=dst_r2 : dst_zone2\g2=dst_g2 : dst_zone2\b2=dst_b2
    Exit
   EndIf
  Next
End Function

Function DST_Set_ScaleRange(dst_zone,dst_sc1#,dst_sc2#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\size_min#=dst_sc1# : dst_zone2\size_max#=dst_sc2#
    Exit
   EndIf
  Next
End Function

Function DST_Set_AlphaRange(dst_zone,dst_a1#,dst_a2#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\alpha_min#=dst_a1# : dst_zone2\alpha_max#=dst_a2#
    Exit
   EndIf
  Next
End Function

Function DST_Set_FadingFar(dst_zone,dst_near#,dst_far#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    If dst_far#<dst_near#
     dst_zone2\farfade_max#=dst_near# : dst_zone2\farfade_min#=dst_far#
    Else
     dst_zone2\farfade_min#=dst_near# : dst_zone2\farfade_max#=dst_far#
    EndIf
    dst_zone2\clipradius#=(dst_zone2\farfade_max#+dst_zone2\size_max#)
    Exit
   EndIf
  Next
End Function

Function DST_Set_FadingNear(dst_zone,dst_near#,dst_far#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    If dst_far#<dst_near#
     dst_zone2\nearfade_max#=dst_near# : dst_zone2\nearfade_min#=dst_far#
    Else
     dst_zone2\nearfade_min#=dst_near# : dst_zone2\nearfade_max#=dst_far#
    EndIf
    Exit
   EndIf
  Next
End Function

Function DST_Set_FX(dst_zone,dst_flag)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\part_flag=dst_flag
    BrushFX dst_zone2\brush,dst_flag
    Exit
   EndIf
  Next
End Function


Function DST_Set_Blend(dst_zone,dst_blend)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\blendmode=dst_blend
    BrushBlend dst_zone2\brush,dst_blend
    Exit
   EndIf
  Next
End Function

Function DST_Set_SpeedBlur(dst_zone,dst_factor#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\speedblur#=dst_factor#
    Exit
   EndIf
  Next
End Function

Function DST_Set_Rotation(dst_zone,dst_w1#,dst_w2#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\rot_min#=dst_w1# : dst_zone2\rot_max#=dst_w2#
    Exit
   EndIf
  Next
End Function

Function DST_Set_Angle(dst_zone,dst_w1#,dst_w2#)
   For dst_zone2.DST_Dustzone = Each DST_Dustzone
    If dst_zone2\pivot=dst_zone
    dst_zone2\angle_min#=dst_w1# : dst_zone2\angle_max#=dst_w2#
    Exit
   EndIf
  Next
End Function



Function DST_CheckZones()
  For dst_dust.DST_Dustobject = Each DST_Dustobject
   If dst_dust\active=1
    dst_dust\zones[0]=0 : dst_dust\oldcount=dst_dust\sharecount : dst_dust\sharecount=0
    dst_dust\dense#=0
   EndIf
  Next
  For dst_zone.DST_Dustzone = Each DST_Dustzone
   If dst_zone\active=1
    dst_dust.DST_Dustobject=Object.DST_Dustobject(dst_zone\dust_handle)
    If dst_zone\radius > EntityDistance(dst_dust\camera,dst_zone\pivot)
     If dst_zone\priority=dst_dust\zones[0]
      If dst_zone\dense#>dst_dust\dense# Then dst_dust\dense#=dst_zone\dense#
      dst_dust\sharecount=dst_dust\sharecount+1
      dst_dust\zones[dst_dust\sharecount]=Handle(dst_zone.DST_Dustzone)
     Else
      If dst_zone\priority>dst_dust\zones[0]
       dst_dust\dense#=dst_zone\dense#
       dst_dust\sharecount=1 : dst_dust\zones[0]=dst_zone\priority
       dst_dust\zones[dst_dust\sharecount]=Handle(dst_zone.DST_Dustzone)
      EndIf
     EndIf
    EndIf
   EndIf
  Next
End Function

Function DST_Update(dst_looptime#=0)
dst_t=MilliSecs()-dst_timer
dst_TIMER=MilliSecs()
If dst_looptime#=0
 dst_looptime#=dst_t/1000.0
EndIf

If dst_checktimer>-1
 dst_check=dst_check+dst_t
 If dst_check>dst_checktimer Then dst_check=0 : dst_checkzones()
EndIf

;dustobjekte vorbereiten
For dst_dust.DST_Dustobject = Each DST_Dustobject
 dst_dust\dist_akt#=EntityDistance(dst_dust\camera,dst_dust\campivot)
 PointEntity dst_dust\campivot,dst_dust\camera
 EntityParent dst_dust\campivot,dst_dust\camera
 PositionEntity dst_dust\campivot,0,0,0
 EntityParent dst_dust\campivot,dst_dust\pivot
 dst_dust\part_count=0
 If dst_dust\sharecount>0 And dst_dust\dense_akt#<1
  dst_dust\dense_akt#=dst_dust\dense_akt#+0.5*dst_looptime#
  If dst_dust\dense_akt#>1 Then dst_dust\dense_akt#=1
 EndIf
 If dst_dust\sharecount=0 And dst_dust\dense_akt#>0
  dst_dust\dense_akt#=dst_dust\dense_akt#-0.5*dst_looptime#
  If dst_dust\dense_akt#<0 Then dst_dust\dense_akt#=0
 EndIf
Next

;partikel bearbeiten
For dst_part.DST_Particle = Each DST_Particle
 dst_dust.DST_Dustobject=Object.DST_Dustobject(dst_part\dust_handle)
 dst_dist#=EntityDistance (dst_dust\camera,dst_part\part)
 
 If dst_part\active=1
  dst_dust\part_count=dst_dust\part_count+1
  dst_zone.DST_Dustzone=Object.DST_Dustzone(dst_part\zone_handle)
  If dst_tmp<>dst_part\zone_handle
   dst_ok=0
   For dst_a=1 To dst_dust\sharecount
    If dst_part\zone_handle=dst_dust\zones[dst_a] Then dst_ok=1 : Exit
   Next
  EndIf
  dst_tmp=dst_part\zone_handle
  ;aktive partikel ausblenden falls objekt oder zone inaktiv wurde
  If dst_ok=0 And dst_part\alphaflag=0
   dst_part\alphaflag=1 : dst_part\alphadest#=0 : dst_part\alphaakt#=1
  EndIf
  If dst_part\alphaflag=1
   If dst_part\alphaakt#>dst_part\alphadest#
    dst_part\alphaakt#=dst_part\alphaakt#-0.5*dst_looptime#
    If dst_part\alphaakt#<=dst_part\alphadest#
     dst_part\alphaakt#=0 : dst_part\alphaflag=0 : dst_part\active=0 : HideEntity dst_part\partpivot
     dst_dust\part_count=dst_dust\part_count-1 : ScaleEntity dst_part\partpivot,1,1,1
    EndIf
   Else
    dst_part\alphaakt#=dst_part\alphaakt#+0.5*dst_looptime#
    If dst_part\alphaakt#>=dst_part\alphadest# Then dst_part\alphaflag=0
   EndIf
   EntityAlpha dst_part\part,dst_part\alpha#*dst_part\alphaakt#
  EndIf

  ;nearfading fr aktive partikel
  If dst_dist#<dst_zone\farfade_max#
   If dst_dist#>dst_zone\nearfade_min# And dst_dist#<dst_zone\nearfade_max#
    dst_alpha#=(dst_dist#-dst_zone\nearfade_min#)/(dst_zone\nearfade_max#-dst_zone\nearfade_min#)*dst_part\alpha#*dst_part\alphaakt#
    EntityAlpha dst_part\part,dst_alpha#
   Else
    If dst_dist#<dst_zone\nearfade_min# Then EntityAlpha dst_part\part,0 
    If dst_dist#>dst_zone\nearfade_max# Then EntityAlpha dst_part\part,dst_part\alpha#*dst_part\alphaakt# 
   EndIf
  EndIf
  If dst_dist#>dst_zone\clipradius# And dst_part\dist_old#<dst_dist#
   dst_part\active=0 : HideEntity dst_part\partpivot : ScaleEntity dst_part\partpivot,1,1,1
   dst_dust\part_count=dst_dust\part_count-1
  EndIf
  ;speedbluring und pointing
  If dst_zone\speedblur#>0 And dst_part\active=1
   EntityParent dst_part\partpivot,dst_dust\campivot
   RotateEntity dst_part\partpivot,0,0,0
   EntityParent dst_part\partpivot,dst_dust\pivot
   dst_blur#=(dst_dust\dist_akt#/(dst_zone\speedblur#*dst_looptime#))*2
   If dst_blur#<1 Then dst_blur#=1
   ScaleEntity dst_part\partpivot,1,1,dst_blur#
  EndIf
  dst_part\angle#=dst_part\angle#+dst_part\rot#*dst_looptime#
  If dst_part\angle#>360 Then dst_part\angle#=dst_part\angle#-360
  PointEntity dst_part\part,dst_dust\camera,dst_part\startangle#+dst_part\angle#
  dst_part\dist_old#=dst_dist#
 EndIf
 ;partikel einsetzen
 If dst_part\active=0
  If dst_dust\active=1
   If dst_dust\sharecount>0
    If dst_dust\part_count<(dst_dust\count*dst_dust\dense#*dst_dust\dense_akt#)
     dst_part\active=1
     dst_dust\part_count=dst_dust\part_count+1
     EntityParent dst_part\partpivot,dst_dust\campivot
     dst_part\zone_handle=dst_dust\zones[Rand(1,dst_dust\sharecount)]
     dst_zone.DST_Dustzone=Object.DST_Dustzone(dst_part\zone_handle)
     If dst_dust\dense_akt#<1
      dst_w#=(1-dst_dust\dense_akt#)*130+50
      PositionEntity dst_part\partpivot,0,0,0
      RotateEntity dst_part\partpivot,Rand(-dst_w#,dst_w#),Rand(-dst_w#,dst_w#),0
      EntityParent dst_part\partpivot,0
      MoveEntity dst_part\partpivot,0,0,dst_zone\clipradius#*Rnd(dst_dust\dense_akt#,1.0)
      dst_part\alphaflag=1 : dst_part\alphaakt#=0 : dst_part\alphadest#=1
     Else
      PositionEntity dst_part\partpivot,0,0,0
      RotateEntity dst_part\partpivot,Rand(-50,50),Rand(-50,50),0
      EntityParent dst_part\partpivot,0
      MoveEntity dst_part\partpivot,0,0,dst_zone\clipradius#
      dst_part\alphaflag=0 : dst_part\alphaakt#=1 
     EndIf
     EntityAutoFade dst_part\part,dst_zone\farfade_min#,dst_zone\farfade_max#
     ShowEntity dst_part\partpivot : ShowEntity dst_part\part
     dst_part\dist_old#=EntityDistance(dst_part\partpivot,dst_dust\camera)
     EntityParent dst_part\partpivot,dst_dust\pivot
     PaintEntity dst_part\part,dst_zone\brush
     dst_part\alpha#=Rnd(dst_zone\alpha_min#,dst_zone\alpha_max#)
     EntityAlpha dst_part\part,dst_part\alpha#*dst_part\alphaakt#
     dst_sc#=Rnd(dst_zone\size_min#,dst_zone\size_max#)
     ScaleEntity dst_part\part,dst_sc#,dst_sc#,dst_sc#
     dst_f#=Rnd(0,1)
     If dst_zone\r1<dst_zone\r2 Then dst_r=(dst_zone\r2-dst_zone\r1)*dst_f#+dst_zone\r1 Else dst_r=(dst_zone\r1-dst_zone\r2)*dst_f#+dst_zone\r2
     If dst_zone\g1<dst_zone\g2 Then dst_g=(dst_zone\g2-dst_zone\g1)*dst_f#+dst_zone\g1 Else dst_g=(dst_zone\g1-dst_zone\g2)*dst_f#+dst_zone\g2
     If dst_zone\b1<dst_zone\b2 Then dst_b=(dst_zone\b2-dst_zone\b1)*dst_f#+dst_zone\b1 Else dst_b=(dst_zone\b1-dst_zone\b2)*dst_f#+dst_zone\b2
     EntityColor dst_part\part,dst_r,dst_g,dst_b
     dst_part\rot#=Rnd(dst_zone\rot_min#,dst_zone\rot_max#)
     dst_part\startangle#=Rnd(dst_zone\angle_min#,dst_zone\angle_max#)
    EndIf
   EndIf
  EndIf
 EndIf
Next 
End Function













Function dst_createflat2(DST_parent)
DST_obj=CreateMesh(DST_parent)
DST_surf=CreateSurface(DST_obj)
DST_v1=AddVertex(DST_surf,.5,0,.5) : DST_v2=AddVertex(DST_surf,-.5,0,.5) : DST_v3=AddVertex(DST_surf,-.5,0,-.5) : DST_v4=AddVertex(DST_surf,.5,0,-.5)
DST_v5=AddVertex(DST_surf,0,0,0)
VertexTexCoords DST_surf,v1,0,1 : VertexTexCoords DST_surf,DST_v2,1,1 : VertexTexCoords DST_surf,DST_v3,1,0 : VertexTexCoords DST_surf,DST_v4,0,0
VertexTexCoords DST_surf,DST_v5,.5,.5
DST_t1=AddTriangle(DST_surf,DST_v2,DST_v1,DST_v5) : DST_t1=AddTriangle(DST_surf,DST_v3,DST_v2,DST_v5) : DST_t1=AddTriangle(DST_surf,DST_v4,DST_v3,DST_v5) : DST_t1=AddTriangle(DST_surf,DST_v1,DST_v4,DST_v5)
UpdateNormals DST_obj
DST_au=5 : DST_av=2 : DST_mi=5
VertexNormal DST_surf,0,DST_au,DST_av,DST_au : VertexNormal DST_surf,1,-DST_au,DST_av,DST_au : VertexNormal DST_surf,2,-DST_au,DST_av,-DST_au : VertexNormal DST_surf,3,DST_au,DST_av,-DST_au
VertexNormal DST_surf,4,0,DST_mi,0
RotateMesh DST_obj,90,0,0
Return DST_obj
End Function

 
Function dst_createflat1(DST_parent)
DST_obj=CreateMesh(DST_parent)
DST_surf=CreateSurface(DST_obj)
DST_v1=AddVertex(DST_surf,.5,0.001,.5) : DST_v2=AddVertex(DST_surf,-.5,0.001,.5) : DST_v3=AddVertex(DST_surf,-.5,0.001,-.5) : DST_v4=AddVertex(DST_surf,.5,0.001,-.5)
VertexTexCoords DST_surf,DST_v1,0,1,0,0 : VertexTexCoords DST_surf,DST_v2,1,1,0,0 : VertexTexCoords DST_surf,DST_v3,1,0,0,0 : VertexTexCoords DST_surf,DST_v4,0,0,0,0
VertexTexCoords DST_surf,DST_v1,0,1,0,1 : VertexTexCoords DST_surf,DST_v2,1,1,0,1 : VertexTexCoords DST_surf,DST_v3,1,0,0,1 : VertexTexCoords DST_surf,DST_v4,0,0,0,1
DST_t1=AddTriangle(DST_surf,DST_v3,DST_v2,DST_v1) : DST_t2=AddTriangle(DST_surf,DST_v1,DST_v4,DST_v3)
UpdateNormals DST_obj
VertexNormal DST_surf,0,1,.01,1 : VertexNormal DST_surf,1,-1,.01,1 : VertexNormal DST_surf,2,-1,.01,-1 : VertexNormal DST_surf,3,1,.01,-1
RotateMesh DST_obj,90,0,0 
Return DST_obj
End Function

Function dst_flipstring$(dst_f$)
dst_l=Len(dst_f$)
For dst_a=dst_l To 1 Step -1
 dst_f2$=dst_f2$+Mid$(dst_f$,dst_a,1)
Next
Return dst_f2$
End Function