; This example shows the use of DST_Dust

; use arrow-keys to move, space for full stop and Return to active Dust-zone animation.
; The Dust-objects are marked with the white cubes and the zones with the colored spheres
; Dust-object "dust" inhabits Dust-zone zone1 and zone2
; zone1 shows moving particles with various dense.
; zone2 (yellow) is attached to dust, has higher priority then zone1 and shows SpeedBlur
; dust2 has only zone3 with violet particles.
; dust2 moves randomly And turns forward at far position to simulate simple snowfall.
Include"DST_Dust.bb"

Graphics3D 800,600,0,2

tc=LoadTexture("cursor3d.bmp",4)
ScaleTexture tc,0.125,.125


cam=CreateCamera()
PositionEntity cam,0,0,100
CameraRange cam,1,100000
l=CreateLight()
AmbientLight 50,50,70

dust=DST_Create_Dust(cam,200,0)
cu=CreateCube(dust)
ScaleEntity cu,50,50,50
zone1=DST_Create_DustZone(dust)
c=CreateSphere(8,zone1)
EntityFX c,16
EntityTexture c,tc
ScaleEntity c,1000,1000,1000
PositionEntity zone1,1400,0,0
DST_Set_ZoneRadius(zone1,1000)
DST_Set_Texture(zone1,"rauch-particle.tga",2)
DST_Set_FadingFar(zone1,250,350)
DST_Set_FadingNear(zone1,30,60)
DST_Set_ScaleRange(zone1,150,200)
DST_Set_FX(zone1,1)
DST_Set_Blend(zone1,1)
DST_Set_AlphaRange(zone1,.25,.75)
DST_Set_ColorRange(zone1,100,100,110,250,250,255)

zone2=DST_Create_DustZone(dust,1)
c2=CreateSphere(8,zone2)
EntityFX c2,16
EntityColor c2,255,200,0
EntityTexture c2,tc
ScaleEntity c2,500,500,500
PositionEntity zone2,1400,0,0
DST_Set_ZoneRadius(zone2,500)
DST_Set_Texture(zone2,"particle.jpg",2)
DST_Set_FadingFar(zone2,200,150)
DST_Set_Dense(zone2,1)
DST_Set_ScaleRange(zone2,4,6)
DST_Set_FX(zone2,1)
DST_Set_Blend(zone2,3)
DST_Set_SpeedBlur(zone2,25)
DST_Set_ColorRange(zone2,255,120,0,255,255,0)
DST_Set_DustZonePriority(zone2,1)


dust2=DST_Create_Dust(cam,200,0)
PositionEntity dust2,0,0,5000
cu2=CreateCube(dust2)
ScaleEntity cu2,50,50,50

zone3=DST_Create_DustZone(dust2)
c3=CreateSphere(8,zone3)
EntityFX c3,16
EntityColor c3,200,0,255
EntityTexture c3,tc
ScaleEntity c3,1500,1500,1500
PositionEntity zone3,100,0,1000
DST_Set_ZoneRadius(zone3,1500)
DST_Set_Texture(zone3,"cloud.jpg",2)
DST_Set_FadingFar(zone3,500,350)
DST_Set_FadingNear(zone3,40,10)
DST_Set_Dense(zone3,1)
DST_Set_ScaleRange(zone3,10,20)
DST_Set_FX(zone3,1)
DST_Set_Blend(zone3,3)
DST_Set_ColorRange(zone3,200,120,255,100,0,255)
DST_Set_Angle(zone3,-100,200)
DST_Set_Rotation(zone3,-20,40)

DST_SetTimer()
DST_Set_Intervall(50)

While KeyHit(1)=0
 looptime#=(MilliSecs()-time)/1000.0
 time=MilliSecs()
 If KeyHit(28)=1 Then turn=1-turn
 If MilliSecs()-t2>timer
  timer=Rand(2000,5000) : t2=MilliSecs()
  v1=Rnd(-250,250) : v2=Rnd(-250,250)
 EndIf 
 If turn=1 
  TurnEntity dust,0,5*looptime#,0 : TurnEntity dust2,-5*looptime#,0,0
  If v2_old#<v2 Then v2_old#=v2_old#+250*looptime#
  If v2_old#>v2 Then v2_old#=v2_old#-250*looptime#
  If v1_old#<v1 Then v1_old#=v1_old#+250*looptime#
  If v1_old#>v1 Then v1_old#=v1_old#-250*looptime#
  w#=w#+50*looptime#
  s#=Sin#(w#) : s2#=Sin(w#*2) : s3#=Sin(w#/5)
  PositionEntity dust2,v1_old*s#,0,v2_old*s2#+5000
  DST_Set_Dense(zone1,s3#/2+0.5)
 EndIf
 If KeyDown(200)=1 Then speed#=speed#+30*looptime#
 If KeyDown(208)=1 Then speed#=speed#-30*looptime#
 If KeyDown(205)=1 Then speed2#=speed2#+30*looptime#
 If KeyDown(203)=1 Then speed2#=speed2#-30*looptime#
 If KeyHit(57)=1 Then speed#=0 : speed2#=0
 MoveEntity cam,speed2#*looptime#,0,speed#*looptime#

 x=MouseX()-400 : y=MouseY()-300
 xm=xm+x+xms#
 ym=ym+y+yms#
 If x<>0 Then xms#=x
 If y<>0 Then yms#=y
 xms#=xms#/1.5
 yms#=yms#/1.5
 If ym>90 Then ym=90
 If ym<-90 Then ym=-90
 MoveMouse 400,300
 RotateEntity cam,ym,-xm,0
t=MilliSecs()
DST_Update(looptime#)
t3=MilliSecs()-t
UpdateWorld()
RenderWorld()
Text 10,10,"FPS: "+Str$(Int(1/looptime#))
Text 10,20,"Update-time: "+Str$(t3)
Text 10,40," Arrow-Keys to move"
Text 10,50," Space to stop"
Text 10,60," Return to activate/deactivate Animation"
Flip
Wend

ClearWorld()